use weather, clear 
twoway bar precip month, by(place, row(1) compact legend(off) note("")) xla(1 "J" 2 "F" 3 "M" 4 "A" 5 "M" 6 "J" 7 "J" 8 "A" 9 "S" 10 "O" 11 "N" 12 "D", tlength(0)) bcolor(ltblue) blcolor(black) yla(0(20)120, nogrid ang(h)) xti("") xsc(r(0.5,12.5)) ytitle(mean precipitation (mm)) || scatter constant month if month == 8, ms(none) mla(SUM) mlabsize(*1.4) mlabcolor(blue)
graph save weather1 , asis replace 
twoway connected mean month, by(place, row(1) compact legend(off) note("")) xla(1 "J" 2 "F" 3 "M" 4 "A" 5 "M" 6 "J" 7 "J" 8 "A" 9 "S" 10 "O" 11 "N" 12 "D", tlength(0)) color(red) yla(32(9)86, nogrid ang(h)) xti("") xsc(r(0.5,12.5)) ytitle("mean temperature") yaxis(1 2) yla(32 "0" 41 "5" 50 "10" 59 "15" 68 "20" 77 "25" 86 "30", axis(2) ang(h)) ymla(64 "    {c 176}C", ang(h) tlength(0) labsize(*2) axis(2)) ymla(64 "{c 176}F    ", ang(h) tlength(0) labsize(*2) axis(1))
graph save weather2, asis replace 
separate mean, by(place) veryshortlabel
gen letter = substr(place,1,1)
twoway line mean? precip , lw(0 ..) lc(red blue black) ms(Sh O T) yla(32 "0" 41 "5" 50 "10" 59 "15" 68 "20" 77 "25" 86 "30", ang(h)) ytitle("mean temperature ({c 176}C)") xti(mean precipitation (mm))  || scatter mean? precip , ms(none ..) mla(letter letter letter) mlabcolor(red blue black) mlabpos(0 ..)  legend(order(- "B   Boston" - "H   Houston" - "S   San Francisco") pos(7) ring(0) col(1))
graph save weather3, asis replace
local N = _N
bysort place (month) : gen first = _n == 1
expand 2 if first
replace month = 13 if _n > `N'
sort place month
twoway line mean? precip , lw(0 ..) lc(red blue black) ms(Sh O T) yla(32 "0" 41 "5" 50 "10" 59 "15" 68 "20" 77 "25" 86 "30", ang(h)) ytitle("mean temperature ({c 176}C)") xti(mean precipitation (mm))  || scatter mean? precip , ms(none ..) mla(letter letter letter) mlabcolor(red blue black) mlabpos(0 ..)  legend(order(- "B   Boston" - "H   Houston" - "S   San Francisco") pos(7) ring(0) col(1))
graph save weather4, asis replace
